<?php
/*
Plugin Name: Yskin's wp-CJK-excerpt
Version: 1.3
Author: Yskin
Author URI: http://yskin.net/
Plugin URI: http://yskin.net/2006/07/mulberrykit.html
Description: 為CJK的Wordpress用戶提供更好的摘要算法，以解決Wordpress默認摘要算法只考慮西方語言的不足
*/

//為不支持mb_strlen()函數的空間自定義一個該函數
if ( !function_exists('mb_strlen') ) {
	function mb_strlen ($text, $encode) {
		if ($encode=='UTF-8') {
			return preg_match_all('%(?:
					  [\x09\x0A\x0D\x20-\x7E]           # ASCII
					| [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
					|  \xE0[\xA0-\xBF][\x80-\xBF]       # excluding overlongs
					| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2} # straight 3-byte
					|  \xED[\x80-\x9F][\x80-\xBF]       # excluding surrogates
					|  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
					| [\xF1-\xF3][\x80-\xBF]{3}         # planes 4-15
					|  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
					)%xs',$text,$out);
		}else{
			return strlen($text);
		}
	}
}

function CJK_excerpt ($text) {
	global $post;

	//禁用中文工具箱對摘要的處理
	remove_filter('the_excerpt', 'mul_excerpt');
	remove_filter('the_excerpt_rss', 'mul_excerpt');

	if ( '' == $text ) {
		$text = $post->post_content;
		$text = apply_filters('the_content', $text);
		$text = str_replace(']]>', ']]&gt;', $text);
		$text = strip_tags($text);

		$text = trim($text);

		//段落數
		$fragmentnum = 1;
		//文字數
		$wordnum = 50;
		$words = explode("\n", $text, $fragmentnum+1);
		$num = 0;
		$output = '';
		do {
			$output = $output . $words[$num] . "\n";
			$num++;
		} while ( (mb_strlen($output, 'UTF-8') < $wordnum) and ($num < min(count($words), $fragmentnum)) );

		if (mb_strlen($output, 'UTF-8') < mb_strlen($text, 'UTF-8')) $output .= '<span class="readmore"><a href="' . get_permalink() . '" title="' . strip_tags(get_the_title()) . '" target="_blank">...詳全文（共' . mb_strlen(preg_replace('/\s/','',html_entity_decode(strip_tags($post->post_content))),'UTF-8') . '字）</a></span><br><hr><p>&nbsp;</p><p>&nbsp;</p>';

		return $output;
	}

	return $text;
}

/*
if ( !function_exists('mb_strlen') ) {
	function CJK_excerpt_warning() {
		echo "
		<div id='CJK_excerpt_warning' class='updated fade-ff0000'><p>Yskin's wp-CJK-excerpt 插件檢測到您的服務器上無法使用 mb_strlen() 函數，可能是因為 Multibyte String 函數庫沒有被安裝，請咨詢您的空間提供商。<br />本插件需要使用 mb_strlen() 函數對 UTF-8 字符串進行處理，現在該函數不能使用，本插件將不再做任何操作以免執行出錯。請禁用本插件，等服務器安裝了 Multibyte String 函數庫後再使用。</p>".
		mb_strlen("插件檢測到您的服務器abcdef", 'UTF-8').
		."
 		</div>
		<style type='text/css'>
		#adminmenu { margin-bottom: 9em; }
		#CJK_excerpt_warning { position: absolute; top: 7em; font-weight: bold; }
		</style>
		";

	}
	add_action('admin_footer', 'CJK_excerpt_warning');
	return;
}
*/

add_filter('get_the_excerpt', 'CJK_excerpt', 9);

?>